/*******************************************
* Large Assignment 1: L- System Lace
* Name: Meiling Traeger
* Email: meilingt@unm.edu
* Course: CS 491, Computational Fabrication
* Due: Thursday Februrary 10th
* 
* To run:
* press ' ' to clear
* press 'a' for abstract fractal
* press 'b' for botanical form
* press 'r' for rogan brown
* press 's' for shapes and Lines
*
********************************************/
import processing.pdf.*;
import Turtle.*;

Turtle t;
abstractFractal l;
botanicalForm b;
shapesLines s;
roganBrown r;

void setup(){
  
  size(1000, 700); // X, Y
  background(183, 232,183);
}

void keyPressed(){
  
  if(key == 'a'){
    /** abstract fractal **/
    
    //beginRecord(PDF, "fractal.pdf");
    t = new Turtle(this);
    t.setX(width/2+325);
    t.setY(height/2-60);
    l = new abstractFractal(20,60); //size, angle
    l.iterate(4);
    l.drawAbstract(t);
    //endRecord();

  
    
  }
  else if(key == 'b'){
    /** botanical form **/
    //beginRecord(PDF, "botanical.pdf");
    t = new Turtle(this);
    t.penUp();
    t.back(height/2 - 10);
    t.left(90);
    t.forward(320);
    t.right(90);
    t.penDown();
    for(int i = 0; i< 3; i++){
      b = new botanicalForm(11,45); //size, angle
      b.iterateB(3);
      b.drawAbstractB(t);
    }
        //endRecord();
  }
  else if(key == 'r'){
    /** rogan brown **/
    
    //beginRecord(PDF, "rogan.pdf");
    t = new Turtle(this);
    
    t.penUp();
    t.penDown();
    for(int i = 0; i< 15; i++){
      r = new roganBrown(100,45); //size, angle 
      r.iterateR(1);
      r.drawRogan(t);
      t.right(150);
    }
    
    //endRecord();
  }
  else if(key == 's'){
    /** shapes and lines **/
    t = new Turtle(this);
    t.penUp();
    t.penDown();
    t.setY(height/2 -100);
    t.setX(width/2 +100);
    for (int i = 0; i < 25 ; i++){
      s = new shapesLines(0.5,125); //size, angle
      s.iterateRandomS(8);
      s.drawShapesLines(t);
      t.right(80);
    }  
  }
  else if(key == 'i'){
    /** save **/
    save("image1.png");
  }
  else if(key == ' '){
    /** clear **/
    clear();
    setup();
  }
}


void draw(){
  
}
