/********************************
* Generates an abstract fractal
*********************************/

class abstractFractal{
  
  String axiom;
  String computedWord;
  String[][] rules = {{"F", "F++F-F-F-F--F++F"}, {"+", "+"}, {"-", "-"}};
  float size, angle;
  
  abstractFractal(float size, float angle){
    this.size = size;
    this.angle = angle;
    axiom = "F+F+F+F+F+F";
    computedWord = axiom;
  }
  
  void iterate(int iterations){
    String tempWord;
    println("starting word: " +computedWord);
    for (int i = 0; i < iterations; i++){
      tempWord = computedWord;
      computedWord = tempWord.replaceAll(rules[0][0], rules[0][1]);
      println("iteration " + i +": " +computedWord);
    }
  }
  
  
  void drawAbstract(Turtle t){
    
    char c;
    for(int i = 0; i<computedWord.length(); i++){
      c = computedWord.charAt(i);
      if(c =='F')
        t.forward(size);
      else if (c == '+')
        t.right(angle);
      else if(c == '-')
        t.left(angle);
    }
  }
}
