/**********************************
* Generates shapes and other lines
***********************************/

class shapesLines{
  
  String axiom = "X";
  float size = 5, angle;
  String computedString;
  String computedWord;
  
  
  shapesLines(float size, float angle){
    this.size = size;
    this.angle = angle;
    axiom = "F+F+F+F+F+F";
    computedWord = axiom;
  }
  
  
 
  String[][] rulesShape = {{"+", "+", "+", "+"},
                      {"-", "-", "-", "-"},
                      {"[", "[", "[", "["},
                      {"]", "]", "]", "]"},
                      {"X", "F[+X][-X]FX", "F-[[X]+X]+F[+FX]-X", "F[-X][+X]"},
                      {"F", "FF", "FF", "FF"}};
  
  
  void iterateRandomS (int iterations) {
    String tempWord;
    println("starting word: " +computedWord);
    for (int i=0; i<iterations; i++) {
      tempWord = computedWord;
      computedWord = "";
      for (int j=0; j<tempWord.length(); j++) { //loop through word
        char c = tempWord.charAt(j);
        for (int k=0; k<rulesShape.length; k++) { //loop through rules
          if (c==rulesShape[k][0].charAt(0)) {
            computedWord = computedWord + rulesShape[k][int(random(1,3))];
            break;
          }
        }
      }
      println("iteration " + i +": " +computedWord);
    }
  }
  
  
    void drawShapesLines(Turtle t) {
    for (int i=0; i<computedWord.length(); i++) {
      switch(computedWord.charAt(i)) {
      case 'F':
        t.forward(size);
        break;
      case 'X':
        //leaf(t);
        break;
      case 'T':
        t.forward(size);
        break;
      case '+':
        t.right(angle);
        break;
      case '-':
        t.left(angle);
        break;
      case '[':
        t.push();
        break;
      case ']':
        t.pop();
        break;
      }
    }
  }
  
  
  
  
  void drawLSystem(Turtle t) {
    for (int i=0; i<computedString.length(); i++) {
      switch(computedString.charAt(i)) {
      case 'F':
        t.forward(size);
        break;
      case 'X':
        fill(255,0,0);
        noStroke();
        ellipse(t.getX(), t.getY(), 2,2);
        stroke(0);
        noFill();
        break;
      case 'T':
        t.forward(size);
        break;
      case '+':
        t.right(angle);
        break;
      case '-':
        t.left(angle);
        break;
      case '[':
        t.push();
        break;
      case ']':
        t.pop();
        break;
      }
    }
  }
  
}
